import { Component, Input, Inject, forwardRef, Output, EventEmitter, ElementRef, Renderer2 } from '@angular/core';
import { DataTable } from './table.component';
import { ROW_TEMPLATE } from './row.template';
import { ROW_STYLE } from "./row.style";
var DataTableRow = (function () {
    function DataTableRow(dataTable, elRef, render2) {
        this.dataTable = dataTable;
        this.elRef = elRef;
        this.render2 = render2;
        this.selectedChange = new EventEmitter();
        this._this = this; // FIXME is there no template keyword for this in angular 2?
    }
    DataTableRow.prototype.ngAfterViewInit = function () {
    };
    Object.defineProperty(DataTableRow.prototype, "selected", {
        get: function () {
            return this._selected;
        },
        set: function (selected) {
            this._selected = selected;
            this.selectedChange.emit(selected);
        },
        enumerable: true,
        configurable: true
    });
    DataTableRow.prototype.ngOnDestroy = function () {
        this.selected = false;
    };
    return DataTableRow;
}());
export { DataTableRow };
DataTableRow.decorators = [
    { type: Component, args: [{
                selector: '[dataTableRow]',
                template: ROW_TEMPLATE,
                styles: [ROW_STYLE]
            },] },
];
/** @nocollapse */
DataTableRow.ctorParameters = function () { return [
    { type: DataTable, decorators: [{ type: Inject, args: [forwardRef(function () { return DataTable; }),] },] },
    { type: ElementRef, },
    { type: Renderer2, },
]; };
DataTableRow.propDecorators = {
    'item': [{ type: Input },],
    'index': [{ type: Input },],
    'width': [{ type: Input },],
    'height': [{ type: Input },],
    'top': [{ type: Output },],
    'selectedChange': [{ type: Output },],
};
//# sourceMappingURL=row.component.js.map