import { EventEmitter, QueryList, TemplateRef, ChangeDetectorRef, ElementRef, Renderer2 } from '@angular/core';
import { DataTableColumn } from './column.component';
import { DataTableRow } from './row.component';
import { DataTableParams } from './types';
import { ColumnEventService } from '../../services/column-event-service';
import { TableProperty } from '../../model/table-property';
import { HeaderProperty } from '../../model/header-property';
export declare class DataTable implements DataTableParams {
    private columnEvent;
    private cdref;
    private el;
    private render2;
    constructor(columnEvent: ColumnEventService, cdref: ChangeDetectorRef, el: ElementRef, render2: Renderer2);
    customColumns: DataTableColumn[];
    updateHeaders(): void;
    updateDatas(): void;
    leftFixedWidth: number;
    unFiexedWidth: number;
    contentHeight: number;
    private leftArr;
    private rightArr;
    private array;
    ready(columns: any): void;
    onSelectAll(event: any): void;
    onSelected(event: any, item: any): void;
    fix_start_b: QueryList<ElementRef>;
    tb_b: QueryList<ElementRef>;
    onMouseOver(event: any, index: any): void;
    headerClicked(column: any, event: any): void;
    onSelectedItem: EventEmitter<{}>;
    goForward: EventEmitter<{}>;
    goBack: EventEmitter<{}>;
    headerClick: EventEmitter<{}>;
    private selectedDatas;
    items: any[];
    private _dataProvider;
    leftSubDataArray: any[];
    leftSubHeaderArray: any[];
    middleHeaderArray: any[];
    rightSubDataArray: any[];
    rightSubHeaderArray: any[];
    private _tableProperty;
    private _headers;
    tableProperty: TableProperty;
    update(): void;
    headers: HeaderProperty[];
    dataProvider: any[];
    itemCount: number;
    columns: QueryList<DataTableColumn>;
    rows: QueryList<DataTableRow>;
    expandTemplate: TemplateRef<any>;
    selectColumn: boolean;
    multiSelect: boolean;
    private _pagination;
    pagination: boolean;
    indexColumnVisible: boolean;
    selectColumnVisible: boolean;
    expandColumnVisible: boolean;
    private _sortBy;
    private _sortAsc;
    private _offset;
    private _limit;
    sortBy: string;
    offset: number;
    limit: number;
    page: number;
    readonly lastPage: number;
}
