import { Component, Input, Output, EventEmitter, ContentChildren, ContentChild, ViewChildren, ChangeDetectorRef, ElementRef, Renderer2 } from '@angular/core';
import { DataTableColumn } from './column.component';
import { DataTableRow } from './row.component';
import { TABLE_TEMPLATE } from './table.template';
import { ColumnEventService } from '../../services/column-event-service';
import * as $ from 'jquery';
var DataTable = (function () {
    function DataTable(columnEvent, cdref, el, render2) {
        this.columnEvent = columnEvent;
        this.cdref = cdref;
        this.el = el;
        this.render2 = render2;
        this.customColumns = [];
        this.leftFixedWidth = 0;
        this.unFiexedWidth = 0;
        this.leftArr = [];
        this.rightArr = [];
        this.array = [];
        this.onSelectedItem = new EventEmitter();
        //下一页事件
        this.goForward = new EventEmitter();
        //上一页事件
        this.goBack = new EventEmitter();
        //表头点击
        this.headerClick = new EventEmitter();
        this.items = [];
        this._dataProvider = [];
        this.leftSubDataArray = [];
        this.leftSubHeaderArray = [];
        this.middleHeaderArray = [];
        this.rightSubDataArray = [];
        this.rightSubHeaderArray = [];
        this._headers = [];
        this.selectColumn = false;
        this.multiSelect = true;
        this._sortAsc = true;
        this._offset = 0;
        this._limit = 10;
    }
    DataTable.prototype.updateHeaders = function () {
        var _this = this;
        if (this.headers.length > 0) {
            this.headers.forEach(function (header) {
                var column = new DataTableColumn();
                column.header = header.header;
                column.fixed = header.fixed;
                column.position = header.position;
                column.property = header.property;
                column.resizable = header.resizable;
                column.width = header.width;
                column.sortable = header.sortable;
                _this.customColumns.push(column);
            });
            this.ready(this.customColumns);
        }
    };
    DataTable.prototype.updateDatas = function () {
        var _this = this;
        var newArr = [];
        for (var i = 0; i < this.limit; i++) {
            var item = this.dataProvider[i];
            var arr = [];
            this.array.forEach(function (oo) {
                var obj = {};
                for (var k in item) {
                    if (k === oo.property) {
                        obj[oo.property] = item[oo.property];
                        obj['width'] = oo.width;
                    }
                }
                arr.push(obj);
            });
            newArr.push(arr);
            var arrLeft = [];
            var oo = {};
            oo["selected"] = false;
            oo["index"] = i;
            this.leftArr.forEach(function (lo) {
                for (var kk in item) {
                    if (kk === lo.property) {
                        arrLeft.push(item[lo.property]);
                    }
                }
            });
            oo["children"] = arrLeft;
            this.leftSubDataArray.push(oo);
        }
        console.log(newArr);
        var listArr = [];
        this.dataProvider.forEach(function (item) {
            var arr = [];
            _this.customColumns.forEach(function (column) {
                var obj = {};
                for (var key in item) {
                    if (key === column.property) {
                        obj[column.property] = item[column.property];
                    }
                }
                arr.push(obj);
            });
            listArr.push(arr);
        });
        this.leftSubDataArray.forEach(function (item) {
            item["data"] = listArr[item.index];
        });
        this.rightArr.forEach(function (ro) {
            var arr = [];
            for (var j = 0; j < _this.limit; j++) {
                var item = _this.dataProvider[j];
                var obj = {};
                obj["property"] = item[ro.property];
                arr.push(obj);
            }
            _this.rightSubDataArray.push(arr);
        });
        this.items = newArr;
        this.cdref.detectChanges();
        this.columnEvent.sendColumnDoneMessage({});
    };
    DataTable.prototype.ready = function (columns) {
        var _this = this;
        var oo = {};
        columns.forEach(function (column) {
            var obj = {};
            for (var key in column) {
                obj[key] = column[key];
            }
            if (column.fixed) {
                if (column.position == "left") {
                    _this.leftArr.push(obj);
                }
                else if (column.position === "right") {
                    _this.rightArr.push(obj);
                }
                else {
                    console.log("没有该类型的position");
                }
            }
            else {
                _this.array.push(obj);
            }
        });
        this.leftSubHeaderArray = this.leftArr;
        this.rightSubHeaderArray = this.rightArr;
        this.middleHeaderArray = this.array;
        this.leftSubHeaderArray.forEach(function (item) {
            _this.leftFixedWidth += item.width;
        });
        this.leftFixedWidth = this.leftFixedWidth + 56;
        this.array.forEach(function (oo) {
            _this.unFiexedWidth += oo.width;
        });
    };
    DataTable.prototype.onSelectAll = function (event) {
        var _this = this;
        this.selectedDatas = [];
        this.leftSubDataArray.forEach(function (item) {
            if (event.target.checked) {
                item.selected = true;
                _this.selectedDatas.push(item.data);
            }
            else {
                item.selected = false;
            }
        });
        this.onSelectedItem.emit(this.selectedDatas);
    };
    DataTable.prototype.onSelected = function (event, item) {
        var _this = this;
        item.selected = event.target.checked;
        this.selectedDatas = [];
        this.leftSubDataArray.forEach(function (item) {
            if (item.selected) {
                _this.selectedDatas.push(item.data);
            }
        });
        this.onSelectedItem.emit(this.selectedDatas);
    };
    DataTable.prototype.onMouseOver = function (event, index) {
        $(".tr-hover").removeClass("tr-hover");
        var targetLeft = $(".fix-start-b").find("tr[class='tr']")[index];
        var targetRight = $(".tb-b").find("tr[class='tr']")[index];
        targetLeft.addClass("tr-hover");
        targetRight.addClass("tr-hover");
    };
    DataTable.prototype.headerClicked = function (column, event) {
        var obj = event.target;
        var targetObj = null;
        if ($(obj).hasClass("ico-sort")) {
            targetObj = $(obj);
        }
        else {
            targetObj = $(obj).find("span[class^='ico-sort']");
        }
        $(".ico-sort").removeClass("ico-sort-rising");
        $(".ico-sort").removeClass("ico-sort-Descending-order");
        if (column.sortAsc) {
            targetObj.removeClass("ico-sort-rising");
            targetObj.addClass("ico-sort-Descending-order");
        }
        else {
            targetObj.removeClass("ico-sort-Descending-order");
            targetObj.addClass("ico-sort-rising");
        }
        column.sortAsc = !column.sortAsc;
        this.headerClick.emit(column);
    };
    Object.defineProperty(DataTable.prototype, "tableProperty", {
        get: function () {
            return this._tableProperty;
        },
        set: function (value) {
            this._tableProperty = value;
            this._limit = this._tableProperty.limit;
            this.selectColumn = this._tableProperty.selectColumn;
            this.multiSelect = this._tableProperty.multiSelect;
            this.pagination = this._tableProperty.pagination;
            this.itemCount = this._tableProperty.itemCount;
            this.page = this._tableProperty.page;
            this.headers = this._tableProperty.headers;
            this.dataProvider = this._tableProperty.dataProvider;
            this.update();
        },
        enumerable: true,
        configurable: true
    });
    DataTable.prototype.update = function () {
        this.updateHeaders();
        this.updateDatas();
        this.cdref.detectChanges();
        this.columnEvent.sendColumnDoneMessage({});
    };
    Object.defineProperty(DataTable.prototype, "headers", {
        get: function () {
            return this._headers;
        },
        set: function (value) {
            this._headers = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "dataProvider", {
        get: function () {
            return this._dataProvider;
        },
        set: function (value) {
            this._dataProvider = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "pagination", {
        get: function () {
            return this._pagination;
        },
        set: function (value) {
            this._pagination = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "sortBy", {
        get: function () {
            return this._sortBy;
        },
        set: function (value) {
            this._sortBy = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "offset", {
        get: function () {
            return this._offset;
        },
        set: function (value) {
            this._offset = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "limit", {
        get: function () {
            return this._limit;
        },
        set: function (value) {
            this._limit = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "page", {
        get: function () {
            return Math.floor(this.offset / this.limit) + 1;
        },
        set: function (value) {
            this.offset = (value - 1) * this.limit;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTable.prototype, "lastPage", {
        get: function () {
            return Math.ceil(this.itemCount / this.limit);
        },
        enumerable: true,
        configurable: true
    });
    return DataTable;
}());
export { DataTable };
DataTable.decorators = [
    { type: Component, args: [{
                selector: 'data-table',
                template: TABLE_TEMPLATE,
                styles: ['../css/all-55698b6b7a.css']
            },] },
];
/** @nocollapse */
DataTable.ctorParameters = function () { return [
    { type: ColumnEventService, },
    { type: ChangeDetectorRef, },
    { type: ElementRef, },
    { type: Renderer2, },
]; };
DataTable.propDecorators = {
    'fix_start_b': [{ type: ViewChildren, args: ["leftData",] },],
    'tb_b': [{ type: ViewChildren, args: ["rightData",] },],
    'onSelectedItem': [{ type: Output },],
    'goForward': [{ type: Output },],
    'goBack': [{ type: Output },],
    'headerClick': [{ type: Output },],
    'tableProperty': [{ type: Input },],
    'headers': [{ type: Input },],
    'dataProvider': [{ type: Input },],
    'itemCount': [{ type: Input },],
    'columns': [{ type: ContentChildren, args: [DataTableColumn,] },],
    'rows': [{ type: ViewChildren, args: [DataTableRow,] },],
    'expandTemplate': [{ type: ContentChild, args: ['dataTableExpand',] },],
    'selectColumn': [{ type: Input },],
    'multiSelect': [{ type: Input },],
    'pagination': [{ type: Input },],
    'sortBy': [{ type: Input },],
    'offset': [{ type: Input },],
    'limit': [{ type: Input },],
    'page': [{ type: Input },],
};
//# sourceMappingURL=table.component.js.map