import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { DataTable } from './components/data-grid/table.component';
import { DataTableColumn } from './components/data-grid/column.component';
import { DataTableRow } from './components/data-grid/row.component';
import { DataTablePagination } from './components/data-grid/pagination.component';
import { DataTableHeader } from './components/data-grid/header.component';
import { CheckBox } from './components/data-grid/checkBox.component';
import { PixelConverter } from './utils/px';
import { Hide } from './utils/hide';
import { MinPipe } from './utils/min';
import { ColumnEventService } from './services/column-event-service';
import { HeaderProperty } from './model/header-property';
import { TableProperty } from './model/table-property';
export * from './components/data-grid/types';
export * from './tools/data-table-resource';
export * from './services/column-event-service';
export { DataTable, DataTableColumn, DataTableRow, DataTablePagination, DataTableHeader, HeaderProperty, TableProperty, ColumnEventService };
export var DATA_TABLE_DIRECTIVES = [DataTable, DataTableColumn];
var DataTableModule = (function () {
    function DataTableModule() {
    }
    DataTableModule.forRoot = function () {
        return {
            ngModule: DataTableModule,
            providers: [ColumnEventService]
        };
    };
    return DataTableModule;
}());
export { DataTableModule };
DataTableModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    DataTableColumn,
                    DataTableHeader,
                    DataTablePagination,
                    DataTableRow,
                    DataTable,
                    HeaderProperty,
                    TableProperty,
                    Hide,
                    MinPipe,
                    PixelConverter,
                    CheckBox
                ],
                exports: [
                    DataTableColumn,
                    DataTableHeader,
                    DataTablePagination,
                    DataTableRow,
                    DataTable,
                    HeaderProperty,
                    TableProperty,
                    Hide,
                    MinPipe,
                    PixelConverter,
                    CheckBox
                ],
                imports: [
                    CommonModule,
                    FormsModule,
                ]
            },] },
];
/** @nocollapse */
DataTableModule.ctorParameters = function () { return []; };
//# sourceMappingURL=index.js.map